//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                                     FiboBars2.mq4|
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0
#property indicator_maximum 1


extern int period = 10;
extern int fiboLevel = 1;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trand[];

double prevTicTrend = 0;

bool oldIsTrandDown;
double level;
#define level1 0.236
#define level2 0.382
#define level3 0.5
#define level4 0.618
#define level5 0.762

extern bool alertMode = false;

datetime barTime = 0;

int init() {
    IndicatorBuffers(3);
 
    SetIndexBuffer(0, ExtMapBuffer1);
    SetIndexBuffer(1, ExtMapBuffer2);
    SetIndexBuffer(2, trand);
    
    SetIndexStyle(0, DRAW_HISTOGRAM);
    SetIndexStyle(1, DRAW_HISTOGRAM);
    
    
    
    SetIndexDrawBegin(0, period);
    SetIndexDrawBegin(1, period);
    SetIndexDrawBegin(2, period);
    SetIndexDrawBegin(3, period);
    SetIndexDrawBegin(4, period);
    

    
    switch(fiboLevel){
    case 1:
        level = level1;
        break;
    case 2:
        level = level2;   
        break;
    case 3:
        level = level3;
        break;
    case 4:
        level = level4;
        break;
    case 5:
        level = level5;
        break;
    default: 
        level = level1;
        break;
    }
    return(0);
}

int deinit(){
    return(0);
}

int start() {
    int indicatorCounted = IndicatorCounted();
    if (indicatorCounted < 0) { 
        return (-1);
    }
    if(indicatorCounted > 0) {
       indicatorCounted--;
    }
   
    int limit = Bars - indicatorCounted;
    for(int i = limit; i >= 0; i--) {
        double maxHigh = High[iHighest(NULL,0,MODE_HIGH, period, i)];
        double minLow = Low[iLowest(NULL,0,MODE_LOW, period, i)]; 
        if(Open[i] > Close[i]) {
           if(!(trand[i+1] < 0  && (maxHigh - minLow) * level < (Close[i] - minLow))) {
              trand[i] = 1;
           } else {
              trand[i] = -1;
           }
        } else {
            if(!(trand[i+1] > 0  && (maxHigh - minLow) * level < (maxHigh - Close[i]))) {
                trand[i] = -1;
            } else {
                trand[i] = 1;
            }
        }
        
        if(alertMode && i == 0 && trand[0] != trand[1]) {
            if(barTime != Time[0]) {
                if (trand[0] == 1) {
                    Alert("FiboBars2: " + Symbol() + " M " + Period() + ": Signal: BUY");
                } else if(trand[0] == -1){
                    Alert("FiboBars2: " + Symbol() + " M " + Period() + ": Signal: SELL");
                }
            }
            barTime = Time[0];
            
            if(prevTicTrend != trand[0]) {
                PlaySound("event.wav");
            }
            prevTicTrend = trand[0];
            
        }
        
        if(trand[i] == 1) {//RED BAR 
            ExtMapBuffer1[i] = 1;
            ExtMapBuffer2[i] = EMPTY_VALUE;
        } else if(trand[i] == -1) {//GREEN BAR
            ExtMapBuffer1[i] = EMPTY_VALUE;
            ExtMapBuffer2[i] = 1; 
        } else {
            ExtMapBuffer1[i] = EMPTY_VALUE;
            ExtMapBuffer2[i] = EMPTY_VALUE; 
        }
    }
    return(0);
}